Bug 69076

Summary: SVG Mask should take 'color-interpolation' into account to determine the color space of the mask image
Product: WebKit Reporter: Dirk Schulze <krit>
Component: SVGAssignee: Dirk Schulze <krit>
Status: RESOLVED FIXED    
Severity: Normal CC: dglazkov, webkit.review.bot, zimmermann
Priority: P2    
Version: 528+ (Nightly build)   
Hardware: Unspecified   
OS: Unspecified   
URL: http://www.w3.org/TR/SVG/masking.html#Masking
Attachments:
Description Flags
Patch simon.fraser: review+, webkit.review.bot: commit-queue-

Description Dirk Schulze 2011-09-29 02:30:27 PDT
SVG Mask should take 'color-interpolation' into account to determine the color space of the mask image. This is a change in SVG 1.1 SE. The color space of the mask image gets defined by the computed value of the 'color-interpolation' property. This will switch the default color space from linearRGB to sRGB (a performance improvement for platforms without native support of linearRGB).
Comment 1 Dirk Schulze 2011-09-29 13:40:11 PDT
Created attachment 109198 [details]
Patch
Comment 2 WebKit Review Bot 2011-09-29 15:50:36 PDT
Comment on attachment 109198 [details]
Patch

Attachment 109198 [details] did not pass chromium-ews (chromium-xvfb):
Output: http://queues.webkit.org/results/9900221

New failing tests:
svg/W3C-SVG-1.1/masking-intro-01-f.svg
svg/custom/mask-colorspace.svg
svg/css/circle-in-mask-with-shadow.svg
svg/custom/grayscale-gradient-mask-2.svg
Comment 3 Dirk Schulze 2011-09-30 01:30:49 PDT
The test results must be updated on linux and windows for chromium. I'd do that on landing.
Comment 4 Simon Fraser (smfr) 2011-09-30 11:55:17 PDT
Comment on attachment 109198 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=109198&action=review

> Source/WebCore/rendering/svg/RenderSVGResourceMasker.cpp:134
> +void RenderSVGResourceMasker::drawContentIntoMaskImage(MaskerData* maskerData, const ColorSpace colorSpace, const SVGMaskElement* maskElement, RenderObject* object)

ColorSpace doesn't need to be const.
Comment 5 Dirk Schulze 2011-10-02 00:14:24 PDT
Committed r96470: <http://trac.webkit.org/changeset/96470>